package cn.gov.customs.wxjy.base.service.impl;

import cn.gov.customs.cacp.sdks.core.user.trans.CacpTransUser;
import cn.gov.customs.wxjy.common.exception.ServiceException;
import cn.gov.customs.wxjy.common.utils.StringUtils;
import cn.gov.customs.wxjy.common.utils.bean.BeanValidators;
import cn.gov.customs.wxjy.common.utils.uuid.SnowflakeIdWorker;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import javax.validation.Validator;
import java.util.List;
import org.apache.commons.collections4.CollectionUtils;
import cn.gov.customs.wxjy.common.utils.DateUtils;
import com.github.pagehelper.PageInfo;
import cn.gov.customs.wxjy.common.utils.DateUtils;
import cn.gov.customs.wxjy.base.dao.GoodsCatalogMapper;
import cn.gov.customs.wxjy.base.pojo.GoodsCatalog;
import cn.gov.customs.wxjy.base.pojo.GoodsCatalogQuery;
import cn.gov.customs.wxjy.base.service.IGoodsCatalogService;

/**
 * 基础数据-危险货物目录Service业务层处理
 *
 * @author xiong
 * @date 2025-12-16
 */
@Service
@Slf4j
@RequiredArgsConstructor
public class GoodsCatalogServiceImpl implements IGoodsCatalogService {

    private final GoodsCatalogMapper goodsCatalogMapper;

    private final Validator validator;

    /**
     * 查询基础数据-危险货物目录
     *
     * @param ID 基础数据-危险货物目录主键
     * @return 基础数据-危险货物目录
     */
    @Override
    public GoodsCatalog selectByID(String ID) {
        return goodsCatalogMapper.selectByID(ID);
    }

    /**
     * 分页查询基础数据-危险货物目录列表
     *
     * @param query
     * @return 基础数据-危险货物目录
     */
    @Override
    public PageInfo<GoodsCatalog> selectPageList(GoodsCatalogQuery query) {
        return PageInfo.of(goodsCatalogMapper.selectList(query));
    }

    /**
     * 查询基础数据-危险货物目录列表
     *
     * @param query
     * @return 基础数据-危险货物目录
     */
    @Override
    public List<GoodsCatalog> selectList(GoodsCatalogQuery query) {
        return goodsCatalogMapper.selectList(query);
    }

    /**
     * 新增基础数据-危险货物目录
     *
     * @param goodsCatalog 基础数据-危险货物目录
     * @return 结果
     */
    @Override
    public int insert(GoodsCatalog goodsCatalog) {
            return goodsCatalogMapper.insert(goodsCatalog);
    }

    /**
     * 修改基础数据-危险货物目录
     *
     * @param goodsCatalog 基础数据-危险货物目录
     * @return 结果
     */
    @Override
    public int update(GoodsCatalog goodsCatalog) {
        return goodsCatalogMapper.update(goodsCatalog);
    }

    /**
     * 批量删除基础数据-危险货物目录
     *
     * @param ids 需要删除的基础数据-危险货物目录主键
     * @return 结果
     */
    @Override
    public int deleteByIDs(String[] ids) {
        return goodsCatalogMapper.deleteByIDs(ids);
    }

    /**
     * 删除基础数据-危险货物目录信息
     *
     * @param ID 基础数据-危险货物目录主键
     * @return 结果
     */
    @Override
    public int deleteByID(String ID) {
        return goodsCatalogMapper.deleteByID(ID);
    }

    /**
     * 逻辑删除基础数据-危险货物目录信息
     *
     * @param ID 基础数据-危险货物目录主键
     * @return 结果
     */
    @Override
    public int logicDelete(String ID) {

        return goodsCatalogMapper.logicDelete(ID);
    }

    /**
     * 导入基础数据-危险货物目录数据
     *
     * @param goodsCatalogList 基础数据-危险货物目录数据列表
     * @param isUpdateSupport 是否更新支持，如果已存在，则进行更新数据
     * @param cacpTransUser 操作用户
     * @return 结果
     */
    @Override
    public String importGoodsCatalog(List<GoodsCatalog> goodsCatalogList, Boolean isUpdateSupport, CacpTransUser cacpTransUser) {
        if (CollectionUtils.isEmpty(goodsCatalogList)) {
            throw new ServiceException("导入数据不能为空！");
        }
        int successNum = 0;
        int failureNum = 0;
        StringBuilder successMsg = new StringBuilder();
        StringBuilder failureMsg = new StringBuilder();
        for (GoodsCatalog goodsCatalog : goodsCatalogList) {
            try {

                BeanValidators.validateWithException(validator, goodsCatalog);
                //id名称不统一，自行处理
                goodsCatalog.setCreateTime(DateUtils.getNowDate());
                goodsCatalog.setUpdateTime(DateUtils.getNowDate());
                goodsCatalog.setCreateUser(cacpTransUser.getUserId());
                goodsCatalog.setCreateDept(cacpTransUser.getParentGuid());

                goodsCatalogMapper.insert(goodsCatalog);
                successNum++;
                successMsg.append("<br/>" + successNum + "、 " + cacpTransUser.getUserName() + " 导入成功");

            } catch (Exception e) {
                failureNum++;
                String msg = "<br/>" + failureNum + "、" + cacpTransUser.getUserName() + " 导入失败：";
                failureMsg.append(msg + e.getMessage());
                log.error(msg, e);
            }
        }
        if (failureNum > 0) {
            failureMsg.insert(0, "很抱歉，导入失败！共 " + failureNum + " 条数据格式不正确，错误如下：");
            throw new ServiceException(failureMsg.toString());
        } else {
            successMsg.insert(0, "恭喜您，数据已全部导入成功！共 " + successNum + " 条，数据如下：");
        }
        return successMsg.toString();
    }
}
